# Validator reward

The `ValidatorReward` entity offers a normalized representation of the Casper Network [Reward](https://docs.casper.network/concepts/glossary/R/#reward) received by a [Validator](/1.3.x/rest-api/validator.md) for a specific era.

## Properties

The `ValidatorReward` entity has the following properties:

| Property     | Type         | Description                                                                                  |
| ------------ | ------------ | -------------------------------------------------------------------------------------------- |
| `public_key` | `string(64)` | Public key of the validator represented as a hexadecimal string. Unique validator identifier |
| `era_id`     | `uint32`     | Era identifier                                                                               |
| `amount`     | `uint64`     | Amount of the reward received by the validator                                               |
| `timestamp`  | `datetime`   | Timestamp indicating when the last block in the era was proposed                             |

**Example**

```json
{
  "public_key": "0106ca7c39cd272dbf21a86eeb3b36b7c26e2e9b94af64292419f7862936bca2ca",
  "era_id": 1,
  "amount": "1000000000000",
  "timestamp": "2023-01-01T12:00:00Z"
}
```

## Optional properties

Depending on the endpoint, the following optional properties may be included in the `ValidatorReward` entity:

| Property | Type      | Description                                                                                                                                                                          |
| -------- | --------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| `rate`   | `float32` | The rate that was relevant at the moment when the last block was proposed. To get more details see [Including CSPR rates](/1.3.x/documentation/highlights/including-cspr-rates.md) . |

## Relations

The `ValidatorReward` entity has the following relations with other entities:

| Entity                                      | Mapping property | Description                                                            |
| ------------------------------------------- | ---------------- | ---------------------------------------------------------------------- |
| [`Validator`](/1.3.x/rest-api/validator.md) | `public_key`     | Validators receive rewards for participating in the consensus process. |

## Endpoints

The `ValidatorReward` entity has the following endpoints:

* [Get validator rewards](/1.3.x/rest-api/validator-reward/get-validator-rewards.md)
* [Get validator total rewards](/1.3.x/rest-api/validator-reward/get-validator-total-rewards.md)

## Relation endpoints

The `ValidatorReward` entity has the following relation endpoints:

* [Get total validator delegators' rewards](https://github.com/make-software/casper-middleware/blob/documentation-1.3.x/docs/public/rest-api/delegator-reward/get-validator-total-delegator-rewards.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cspr.cloud/1.3.x/rest-api/validator-reward.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
